#declare T_china1 = texture{pigment{wood color_map { [ 0.0 White ] [ 0.8 White ] [ 0.85 Blue ] [ 0.9 Blue ] [ 0.95 White ] [ 1.0 White ] }}}
                    texture {pigment {spotted color_map {[0 color rgbf<.4,.16,.16,.8>][.3 color rgbf<1,1,1,1>][ 0.734  color rgbf<1,1,1,1> ][ 1 color rgbf<0.4, 0.16, 0.16,.8> ] } turbulence 0.8  frequency 1.5  scale .2}}
                    
#declare T_china2 = texture{pigment{gradient z color_map {[ 0.0 White ] [ 0.75 White ] [ 0.8 Blue ] [ 0.9 Blue ] [ 0.95 White ] [ 1.0 White ]}}}
#declare T_china3 = texture{pigment{White}}

#macro plate()
        lathe{quadratic_spline 6,
                <0,0><100,0><130,10><130,13><100,3><0,3>
                rotate x*90 texture{T_china1 scale 210}
              }
#end

#macro bowl()
        lathe{quadratic_spline 6,
                <0,0><60,0><90,50><88,52><60,3><0,3>
                rotate x*90 texture{T_china1 scale 140}
              }
#end

#macro mug()
        union{
                lathe{quadratic_spline 8,
                        <0,0><25,0><28,7><27,14><40,90><38,90><38,3><0,3>
                        rotate x*90
                        texture{T_china2 scale 50}
                        }
                 #declare xs=0;
                 #declare ys=0;
                 #declare zs=25;
                 #declare theta=0;
                 #declare phi=0;
                 #declare leaddiameter=17;
                 union{
                        wirepiece(50,0,45)
                        wirepiece(20,0,75)
                        wirepiece(0,0,85)
                        scale <.5,1,1>
                        translate x*40
                        texture {T_china3}
                       }
                 
              }
#end

#macro trophy()
        #declare xs=0;
         #declare ys=0;
         #declare zs=50;
         #declare theta=0;
         #declare phi=-10;
         #declare leaddiameter=17;
         #declare handle=
         union{
                wirepiece(100,0,90)
                wirepiece(40,0,150)
                wirepiece(0,0,170)
                scale <.3,1,1>
               }

        union{
                lathe{quadratic_spline 9,
                        <0,0><60,0><15,5><5,15><5,40><18,60><60,120><60,190><0,60>
                        //texture{T_Silver_1A}
                        //normal{bump_map{gif "trophy.gif" map_type 1} bump_size 3} 
                        rotate x*90
                        }
                object{handle translate <40,0,50>}     
                object{handle rotate z*180 translate <-40,0,50>}
                texture {T_Silver_1A}
              }
#end

#macro book1(bookw,bookd,bookh,spinepic)
        difference{
                box{0,<bookd,bookw,bookh>
                        pigment{image_map{gif spinepic} rotate <90,0,90> scale <bookd,bookw,bookh>}
                        normal{wrinkles  scale <1,1,10> rotate z*90}
                    }
                box{<1,1,bookh-1><bookd-1,bookw-1,bookh+1> pigment{rgb .5}}
                   }
#end

#macro paper(paperl,paperw,curverad,image)
        #declare paperthick=.01;
        intersection{
                difference{
                        cylinder{<0,-paperl,curverad><0,paperl,curverad>,curverad}
                        cylinder{<0,-paperl-1,curverad><0,paperl+1,curverad>,curverad-paperthick}
                          }
                 box{<-paperl/2,-paperw/2,0><paperl/2,paperw/2,curverad>}
                 pigment{image_map{gif image}
                        rotate <180,0,90> scale <paperl,paperw,1>
                        translate <paperl/2,paperw/2,0>}
                 normal{wrinkles .1}
                    }
#end

#macro paperstack1()
        union{
                paper(297,210,800,"note.gif")
                object{paper(297,210,700,"book_ggs.gif") rotate z*10 translate z*2}
                object{paper(297,210,600,"book_ggs.gif") rotate z*15 translate z*4}
                object{paper(297,210,550,"book_ggs.gif") rotate z*12 translate z*6}
                object{paper(297,210,500,"morgenstemmning.gif") rotate z*20 translate z*8}
        }
#end

#macro paperstack2()
        union{
                paper(297,210,800,"note.gif")
                object{paper(297,210,700,"book_ggs.gif") rotate z*10 translate z*2}
                object{paper(297,210,600,"book_ggs.gif") rotate z*15 translate z*4}
                object{paper(297,210,550,"book_ggs.gif") rotate z*12 translate z*6}
                object{paper(297,210,500,"mietvertrag.gif") rotate z*200 translate z*20}
                object{paper(297,210,500,"mietvertrag.gif") rotate z*204 translate z*24}
                object{paper(297,210,500,"mietvertrag.gif") rotate z*208 translate z*26}
        }
#end

#macro paperstack3()
        union{
                object{paper(297,210,700,"book_ggs.gif") rotate z*10 translate z*2}
                object{paper(297,210,600,"book_ggs.gif") rotate z*15 translate z*4}
                object{paper(297,210,550,"misco.gif") rotate z*12 translate z*6}
        }
#end

#macro paperstack4()
        union{
                object{paper(297,210,600,"book_ggs.gif") rotate z*10 translate z*2}
                object{paper(297,210,500,"book_ggs.gif") rotate z*15 translate z*4}
                object{paper(297,210,400,"misco.gif") rotate z*12 translate z*6}
        }
#end


#macro picture1(l,h,image,bgcol)
        #declare frameth=10;
        union{
                cylinder{0,<0,0,h>,frameth scale <1,.5,1> translate <-(l-frameth)/2,0,-(h-frameth)/2>}
                cylinder{0,<0,0,h>,frameth scale <1,.5,1> translate <(l-frameth)/2,0,-(h-frameth)/2>}
                cylinder{0,<l,0,0>,frameth scale <1,.5,1> translate <-l/2,0,frameth-h/2>}
                cylinder{0,<l,0,0>,frameth scale <1,.5,1> translate <-l/2,0,h/2>}
                box{0,<l,0.01,h> pigment{bgcol} translate<-l/2,0,-h/2>}
                box{<-l*.4,0,-h*.3><l*.4,-.01,h*.4> pigment{image_map{gif image} rotate x*90 scale <l*.8,1,h*.7> translate <-l*.4,0,-h*.3>}}
                texture{T_Silver_1A}
             }
#end

#macro picture2(l,h,image,bgcol)
        #declare frameth=10;
        union{
                cylinder{0,<0,0,h>,frameth scale <1,.5,1> translate <-(l-frameth)/2,0,-(h-frameth)/2>}
                cylinder{0,<0,0,h>,frameth scale <1,.5,1> translate <(l-frameth)/2,0,-(h-frameth)/2>}
                cylinder{0,<l,0,0>,frameth scale <1,.5,1> translate <-l/2,0,frameth-h/2>}
                cylinder{0,<l,0,0>,frameth scale <1,.5,1> translate <-l/2,0,h/2>}
                box{0,<l,0.01,h> pigment{bgcol} translate<-l/2,0,-h/2>}
                box{<-l*.4,0,-h*.3><l*.4,-.01,h*.4> pigment{image_map{gif image} rotate x*90 scale <l*.8,1,h*.7> translate <-l*.4,0,-h*.3>}}
                texture{T_Wood2}
             }
#end

#macro speaker()
        object{chamferbox(150,150,300,40,10) pigment{rgb .1} translate z*150}
#end